<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Modelo de Franquicia</strong>
    </div>
    <!-- <div class="cotm">
      <div class="tmod">
        <strong>Consulta la información de tus sucursales</strong>
      </div>
    </div>-->
    <!-- Contenido -->
    <div class="contSecc">
      <div class="titSecCard">Búsqueda</div>
      <v-card style="background-color: #fafafa;">
        <v-container fluid>
          <div class="indicaciones">
            Consulta la información de tus sucursales, completa los campos por
            los que deseas buscar.
          </div>
          <v-row align="center">
            <!-- CECO / SUCURSAL -->
            <v-col cols="4">
              <div class="titCampos">Sucursal</div>
              <v-autocomplete
                outlined
                :items="metadata.cecos"
                item-value="ceco"
                item-text="ceco"
                dense
                hide-no-data
                placeholder="Busca una sucursal"
                append-icon
                :search-input.sync="textoIngresado"
                @keyup="actualizaCecos"
                @change="llenaSelect"
                return-object
                v-model="cecoSeleccionado"
              ></v-autocomplete>
            </v-col>
          </v-row>

          <v-row align="center">
            <!-- TIPO VISITA -->
            <v-col cols="4">
              <div class="titCampos">Tipo de recorrido</div>
              <v-select
                v-model="selected"
                :value="''"
                :items="metadata.tiposRecorrido"
                placeholder="Selecciona un tipo de recorrido"
                dense
                outlined
                @click="getSeleccionado()"
              ></v-select>
            </v-col>
            <!-- FECHA INICIO -->
            <v-col cols="4">
              <div class="titCampos">Fecha Inicio</div>
              <v-flex>
                <v-menu
                  ref="menuInicio"
                  v-model="menuInicio"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  :return-value.sync="fechaInicio"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      outlined
                      dense
                      v-model="fechaInicio"
                      placeholder="Selecciona una fecha inicio"
                      prepend-icon
                      readonly
                      v-on="on"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaInicio"
                    no-title
                    scrollable
                    color="#ffcd00"
                  >
                    <v-spacer></v-spacer>
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuInicio.save(fechaInicio)"
                      >Seleccionar</v-btn
                    >
                    <v-btn text color="primary" @click="menuInicio = false"
                      >Cancelar</v-btn
                    >
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuInicio.save(null)"
                      >Limpiar</v-btn
                    >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
            <!-- FECHA FIN -->
            <v-col cols="4">
              <div class="titCampos">Fecha Fin</div>
              <v-flex>
                <v-menu
                  ref="menuFin"
                  v-model="menuFin"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  :return-value.sync="fechaFin"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      outlined
                      dense
                      v-model="fechaFin"
                      placeholder="Selecciona una fecha fin"
                      prepend-icon
                      readonly
                      v-on="on"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaFin"
                    no-title
                    scrollable
                    color="#ffcd00"
                  >
                    <v-spacer></v-spacer>
                    <v-btn
                      text
                      color="primary"
                      @click="
                        $refs.menuFin.save(fechaFin);
                        validaFecha();
                      "
                      >Seleccionar</v-btn
                    >
                    <v-btn text color="primary" @click="menuFin = false"
                      >Cancelar</v-btn
                    >
                    <v-btn
                      text
                      color="primary"
                      @click="$refs.menuFin.save(null)"
                      >Limpiar</v-btn
                    >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
          </v-row>
          <br />
          <v-row align="center">
            <!-- BUSCAR -->
            <v-col cols="4"></v-col>
            <v-col cols="4">
              <v-btn block color="primary" @click="getInfoSucursal" dark>
                <strong style="font-size: 16px; color: #000;">Buscar</strong>
              </v-btn>
            </v-col>
            <v-col cols="4"></v-col>
          </v-row>
        </v-container>
      </v-card>
      <br />
      <!-- TABLA -->
      <div class="titSecCard" v-show="infoSucursalResult">
        Resultados de búsqueda
      </div>
      <v-card
        id="tablaResultados"
        v-show="infoSucursalResult"
        style="background-color: #fafafa;"
      >
        <v-card-title>
          <v-spacer></v-spacer>
          <v-col cols="4">
            <v-text-field
              outlined
              v-model="search"
              append-icon="mdi-magnify"
              placeholder="Buscar..."
              single-line
              dense
              hide-details
            ></v-text-field>
          </v-col>
        </v-card-title>
        <v-data-table
          :headers="encabezados"
          :items="datosSucursal"
          :search="search"
          class="tabla"
        >
          <template v-slot:item="row">
            <tr>
              <td align="center">{{ row.item.nombreCeco }}</td>
              <td align="center">{{ row.item.ceco }}</td>
              <td align="center">{{ row.item.zona }}</td>
              <td align="center">{{ row.item.region }}</td>
              <td align="center">{{ row.item.idRecorrido }}</td>
              <!--<td align="center">{{getNomRecorrido(row.item.idRecorrido)}}</td>-->
              <td align="center">{{ row.item.perido }}</td>
              <td align="center">{{ row.item.pondTot }}</td>
              <td align="center">
                <a
                  class="liga"
                  @click="descargaHallazgo(row.item)"
                  block
                  style="color: #2d2926"
                  >Descargar</a
                >
              </td>
              <td align="center">
                <a
                  class="liga"
                  @click="descargaHistorial(row.item)"
                  block
                  style="color: #2d2926"
                  >Descargar</a
                >
              </td>
              <td align="center">
                <a
                  class="liga"
                  @click="descargaDashboard(row.item)"
                  block
                  style="color: #2d2926"
                  >Descargar</a
                >
              </td>

              <td align="center">
                <a
                  class="liga"
                  @click="descargaAdicionales(row.item)"
                  block
                  style="color: #2d2926"
                  >Descargar</a
                >
              </td>

              <td align="center">
                <a
                  class="liga"
                  @click="descargaGeneraReporte(row.item)"
                  block
                  style="color: #2d2926"
                  >Descargar</a
                >
              </td>
            </tr>
          </template>
        </v-data-table>
      </v-card>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>
<style scoped></style>
<script>
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
export default {
  data() {
    return {
      cecoValue: "",
      menuInicio: false,
      menuFin: false,
      modal: false,
      cecoSeleccionado: "",
      nombreCecoSeleccionado: "",
      tipoRecorrido: "",
      fechaInicio: "",
      fechaFin: "",
      textoIngresado: "",
      infoSucursalResult: false,
      selected: "Todos",
      metadata: {
        tiposRecorrido: [],
        cecos: [],
      },
      search: "",
      encabezados: [
        { text: "Sucursal", value: "nombreCeco", align: "center" },
        { text: "CECO", value: "ceco", align: "center" },
        { text: "Zona", value: "zona", align: "center" },
        { text: "Región", value: "region", align: "center" },
        { text: "Recorrido", value: "idRecorrido", align: "center" },
        { text: "Fecha", value: "perido", align: "center" },
        { text: "Calificación", value: "pondTot", align: "center" },
        { text: "Hallazgos", value: "hallazgos", align: "center" },
        {
          text: "Historial de Hallazgos",
          value: "historialHallazgos",
          align: "center",
        },
        { text: "Dashboard", value: "dashboard", align: "center" },
        { text: "Adicionales", value: "adicionales", align: "center" },
        { text: "Genera Acta", value: "acta", align: "center" },
      ],
      datosSucursal: [
        {
          fase: null,
          proyecto: null,
          idCanal: null,
          hallazgos: null,
          historialHallazgos: null,
          dashboard: null,
          idBita: null,
          idResp: null,
          idArbol: null,
          observ: null,
          idPreg: null,
          idCheck: null,
          idPosible: null,
          idObserv: null,
          posible: null,
          pregunta: null,
          idcritica: null,
          idcheckUsua: null,
          idUsu: null,
          checklist: null,
          idOrdenGru: null,
          idperiodicidad: null,
          respuestaAbierta: null,
          idRespAb: null,
          banderaRespAb: null,
          modulo: null,
          precalif: null,
          clasif: null,
          calCheck: null,
          bitGral: null,
          fechaTermino: null,
          idRecorrido: null,
          ceco: null,
          nombreCeco: null,
          activoCeco: null,
          cecoSuperior: null,
          direccion: null,
          region: null,
          territorio: null,
          zona: null,
          aperturable: null,
          perido: null,
          aux: null,
          aux2: null,
          pregPadre: null,
          version: null,
          fechaIni: null,
          fechaFin: null,
          bita1: null,
          bita2: null,
          pregFilt: null,
          ruta: null,
          nomCeco: null,
          nomUsu: null,
          obs: null,
          pondTot: null,
          sumPreg: null,
          sum: null,
          listaImperdonables: null,
        },
      ],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Infraestructura",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Información de sucursales",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_info_recorridos",
          },
        },
      ],
    };
  },
  methods: {
    getCecos() {
      axiosChecklist
        .get(
          "/expansionCoreServices/getTipoRecorrido.json?ceco=" +
            this.textoIngresado
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = response.data;
              this.tipoRecorrido = response.data[0].status;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (this.textoIngresado != null && this.textoIngresado.length > 2) {
        this.getCecos();
      } else if (this.textoIngresado == null || this.textoIngresado == "") {
        this.cecoSeleccionado = "";
        this.metadata.cecos = [];
        this.tipoRecorrido = "";
        this.metadata.tiposRecorrido = [];
        this.fechaInicio = "";
        this.fechaFin = "";
        this.nombreCecoSeleccionado = "";
        this.selected = "Todos";
      }
    },
    getInfoSucursal() {
      var fechaIniParam = "";
      var fechaFinParam = "";

      if (this.cecoSeleccionado != null) {
        var res = this.cecoSeleccionado.ceco.split(" - ");
        this.nombreCecoSeleccionado = res[0];
        let idCecoSeleccionado = res[1];
        if (this.selected === "Todos") {
          this.tipoRecorrido = "";
        }
        if (this.fechaInicio == null) {
          this.fechaInicio = "";
        } else if (this.fechaInicio != "") {
          fechaIniParam =
            this.fechaInicio.split("-")[2] +
            this.fechaInicio.split("-")[1] +
            this.fechaInicio.split("-")[0];
        }

        if (this.fechaFin == null) {
          this.fechaFin = "";
        } else if (this.fechaFin != "") {
          fechaFinParam =
            this.fechaFin.split("-")[2] +
            this.fechaFin.split("-")[1] +
            this.fechaFin.split("-")[0];
        }

        if (this.metadata.tiposRecorrido)
          axiosChecklist
            .get(
              "/expansionCoreServices/getInfoRecorridos.json?idCeco=" +
                idCecoSeleccionado +
                "&nombreCeco=" +
                this.nombreCecoSeleccionado +
                "&tipoRecorrido=" +
                this.tipoRecorrido +
                "&fechaInicio=" +
                fechaIniParam +
                "&fechaFin=" +
                fechaFinParam
            )
            .then((response) => {
              if (response) {
                if (response.status === 200) {
                  this.datosSucursal = response.data;
                  var i = 0;
                  for (i = 0; i < this.datosSucursal.length; i++) {
                    if (this.datosSucursal[i].idRecorrido === "1") {
                      this.datosSucursal[i].idRecorrido =
                        "Validación de Edificación Terminada";
                    } else if (this.datosSucursal[i].idRecorrido === "2") {
                      this.datosSucursal[i].idRecorrido = "Validación Técnica";
                    } else if (this.datosSucursal[i].idRecorrido === "3") {
                      this.datosSucursal[i].idRecorrido =
                        "Validación Recepción de Obra";
                    } else if (this.datosSucursal[i].idRecorrido === "4") {
                      this.datosSucursal[i].idRecorrido = "Validación Caminata";
                    } else if (this.datosSucursal[i].idRecorrido === "5") {
                      this.datosSucursal[i].idRecorrido = "Soft Opening";
                    }
                  }
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {});
      } else {
        alert("Necesitas Seleccionar un Ceco");
      }
      this.infoSucursalResult = true;
    },
    validaFecha() {
      if (this.fechaInicio != null) {
        var fi = new Date();
        var ff = new Date();

        var fechaInicial = this.fechaInicio.split("-");
        var fechaFinal = this.fechaFin.split("-");

        fi.setFullYear(fechaInicial[2], fechaInicial[1], fechaInicial[0]);
        ff.setFullYear(fechaFinal[2], fechaFinal[1], fechaFinal[0]);

        if (ff >= fi) {
          return true;
        } else {
          alert("LA FECHA FIN DEBE SER MAYOR A LA INICIAL");
          return false;
        }
      } else {
        alert("SIN FECHA INICIAL");
        this.fechaFin = null;
      }
    },
    llenaSelect() {
      var arr = new Array();
      if (
        this.metadata.cecos[0].idCanal === 28 ||
        this.metadata.cecos[0].idCanal === 25
      ) {
        arr[0] = "Todos";
        /*if (4 === this.tipoRecorrido) {
          arr[1] = "Validación Caminata";
          this.tipoRecorrido = this.tipoRecorrido - 3;
        } else if (5 === this.tipoRecorrido) {
          arr[1] = "Validación Caminata";
          arr[2] = "Soft Opening";
          this.tipoRecorrido = this.tipoRecorrido - 3;
        } else {
          arr = null;
        }*/
      } else {
        arr[0] = "Todos";
        /*if (1 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
        } else if (2 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
        } else if (3 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
        } else if (4 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
          arr[4] = "Validación Caminata";
        } else if (5 === this.tipoRecorrido) {
          arr[1] = "Validación de Edificación Terminada";
          arr[2] = "Validación Técnica";
          arr[3] = "Validación Recepción de Obra";
          arr[4] = "Validación Caminata";
          arr[5] = "Soft Opening";
        } else {
          arr = null;
        }*/
      }
      this.metadata.tiposRecorrido = arr;
    },
    getSeleccionado() {
      //alert(this.metadata.cecos[0].idCanal);
      if (
        this.metadata.cecos[0].idCanal === 28 ||
        this.metadata.cecos[0].idCanal === 25
      ) {
        //alert("If");
        if (this.selected === "Validación Caminata") {
          this.tipoRecorrido = 1;
        } else if (this.selected === "Soft Opening") {
          this.tipoRecorrido = 2;
        }
      } else {
        //alert("Else");
        if (this.selected === "Validación de Edificación Terminada") {
          this.tipoRecorrido = 1;
        } else if (this.selected === "Validación Técnica") {
          this.tipoRecorrido = 2;
        } else if (this.selected === "Validación Recepción de Obra") {
          this.tipoRecorrido = 3;
        } else if (this.selected === "Validación Caminata") {
          this.tipoRecorrido = 4;
        } else if (this.selected === "Soft Opening") {
          this.tipoRecorrido = 5;
        }
      }
      //alert(this.tipoRecorrido);
    },
    getNomRecorrido(idRecorrido) {
      //alert(idRecorrido);
      var cadena = "";
      if (idRecorrido.value === 1) {
        cadena = "Validación de Edificación Terminada";
      } else if (idRecorrido.value === 2) {
        cadena = "Validación Técnica";
      } else if (idRecorrido.value === 3) {
        cadena = "Validación Recepción de Obra";
      } else if (idRecorrido.value === 4) {
        cadena = "Validación Caminata";
      } else if (idRecorrido.value === 5) {
        cadena = "Soft Opening";
      }
      //alert(cadena);
      return cadena;
    },
    descargaHallazgo(item) {
      //alert("Hallazgo: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "/expansionCoreServices/generaHallazgos.json?ceco=" +
            item.ceco +
            "&proyecto=" +
            item.proyecto +
            "&fase=" +
            item.fase,
          {
            responseType: "blob",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              let blob = new Blob([response.data], {
                type: "aplication/vnd.ms-excel",
              });
              let fileURL = window.URL.createObjectURL(blob);
              let fileLink = document.createElement("a");
              fileLink.href = fileURL;
              fileLink.download =
                "Hallazgos_Ceco_" + item.ceco + "_fase_" + item.fase + ".xls";
              fileLink.click();
              window.URL.revokeObjectURL(fileURL);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    descargaAdicionales(item) {
      //alert("Hallazgo: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "/expansionCoreServices/generaAdicionales.json?ceco=" +
            item.ceco +
            "&proyecto=" +
            item.proyecto +
            "&fase=" +
            item.fase,
          {
            responseType: "blob",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              let blob = new Blob([response.data], {
                type: "aplication/vnd.ms-excel",
              });
              let fileURL = window.URL.createObjectURL(blob);
              let fileLink = document.createElement("a");
              fileLink.href = fileURL;
              fileLink.download =
                "Adicionales_Ceco_" + item.ceco + "_fase_" + item.fase + ".xls";
              fileLink.click();
              window.URL.revokeObjectURL(fileURL);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    descargaHistorial(item) {
      //alert("Historial: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "/expansionCoreServices/generaHistorialHallazgos.json?ceco=" +
            item.ceco +
            "&proyecto=" +
            item.proyecto +
            "&fase=" +
            item.fase,
          {
            responseType: "blob",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              let blob = new Blob([response.data], {
                type: "aplication/vnd.ms-excel",
              });
              let fileURL = window.URL.createObjectURL(blob);
              let fileLink = document.createElement("a");
              fileLink.href = fileURL;
              fileLink.download =
                "Historial_Hallazgos_Ceco_" +
                item.ceco +
                "_fase_" +
                item.fase +
                ".xls";
              fileLink.click();
              window.URL.revokeObjectURL(fileURL);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    descargaDashboard(item) {
      //alert("Dashboard: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "/expansionCoreServices/generaDashboard.json?ceco=" +
            item.ceco +
            "&proyecto=" +
            item.proyecto +
            "&fase=" +
            item.fase,
          {
            responseType: "blob",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              let blob = new Blob([response.data], {
                type: "aplication/vnd.ms-excel",
              });
              let fileURL = window.URL.createObjectURL(blob);
              let fileLink = document.createElement("a");
              fileLink.href = fileURL;
              fileLink.download =
                "Dashboard_Ceco_" + item.ceco + "_fase_" + item.fase + ".xls";
              fileLink.click();
              window.URL.revokeObjectURL(fileURL);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    descargaGeneraReporte(item) {
      //alert("Hallazgo: " + item.ceco + ", " + item.fase + ", " + item.proyecto);
      axiosChecklist
        .get(
          "/expansionCoreServices/generaActaRecorrido.json?idUsuario=189871&idCeco=" +
            item.ceco +
            "&idFase=" +
            item.fase +
            "&idProyecto=" +
            item.proyecto +
            "&nombreSucursal=" +
            item.nombreCeco +
            "&zona=" +
            item.zona +
            "&region=" +
            item.region +
            "&fase=" +
            item.idRecorrido +
            "&calificacion=" +
            item.pondTot +
            "&fecha=" +
            item.perido,
          {
            responseType: "blob",
          }
        )
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              let blob = new Blob([response.data], {
                type: "aplication/pdf",
              });
              let fileURL = window.URL.createObjectURL(blob);
              let fileLink = document.createElement("a");
              fileLink.href = fileURL;
              fileLink.download =
                "reporte_" + item.ceco + "_" + item.idRecorrido + ".pdf";
              fileLink.click();
              window.URL.revokeObjectURL(fileURL);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
  },
  created() {},
};
</script>
